#include <windows.h>
#include "support.h"
#include "xmlParser.h"

TCallBack *PCallBack;
extern TCallBack callback;

//convert long integer to a string
String toString(long x) {
	char buffer[256];
	sprintf(buffer,"%ld",x);
	return String(buffer);
}

String toString(int x) {
	char buffer[256];
	sprintf(buffer,"%d",x);
	return String(buffer);
}

String toString(bool x) {
	char buffer[256];
	if(x==true)
		sprintf(buffer,"true",x);
	else
		sprintf(buffer,"false",x);
	return String(buffer);
}

String toString(unsigned x) {
	char buffer[256];
	sprintf(buffer,"%u",x);
	return String(buffer);
}

String toString(double x) {
	char buffer[256];
	sprintf(buffer,"%lf",x);
	return String(buffer);
}

String toString(float x) {
	char buffer[256];
	sprintf(buffer,"%f",x);
	return String(buffer);
}
//This function subdivides a string in a list of strings
StringList SubdivideString(String str,String divider){
	StringList strings;//returned StringList
	strings.clear();//clear returned stringlist

	int c=0;
	int l=str.length();

	//process entire string
	while(c<l){
		String resultstr;
		resultstr.clear();
		//read characters until divider is encountered
		while((str[c]!=divider[0]) && c<l){
			resultstr=resultstr + str[c];
			c++;
		}
		//Remove spaces \t and \n from string in my implementation...
		//pay attention or change it in dll.h if you don't want to remove
		//a particular char.
		resultstr.Trim();//trims string resultstr
		strings.Add(resultstr);//add trimmed string
		c++;
	}
	return strings;
}

/* OLD FUNCTIONS NOT NEEDED ANYMORE, JUST IF YOU WANT TO CREATE OLD STILE PLUGINS UNCOMMENT

// adds the length of a string in bytes to that string,
// including the length of the 'length' string itself!
String AddLengthToHeader(String header){
long len=header.length()+(toString(header.length())).length()+1;
String tempStr = toString(len)+String(";")+header;
if (tempStr.length() > len) len++;
return (toString(len)+String(";")+header);
}

// this function reads the header length and then extract
// the whole header from data...
StringList GetHeader(String data,String delimeter){
int position = 0;
String myStr;
myStr.clear();
while (data[position] != delimeter[0]){      // headerlength is the first value of data
myStr = myStr + data[position];
position++;
}
int headerlength = atoi(myStr.c_str());
myStr.clear();
myStr = data.substr(0,headerlength);            // retrieve complete header from data
return SubdivideString(myStr,delimeter);      // return as stringlist

}
*/
#ifndef NO_MESSAGES
//this function show an error message when giving callback error code
void ErrorMessage(unsigned error){
	String errore;
	errore.clear();
	errore.append("Error Code ");
	errore=errore+toString(error)+String(": ");
	switch(error){
		case PE_NODATA :
			errore.append("No Data present.");
			break;
		case PE_INVALIDVERSION :
			errore.append("Invalid Version.");
			break;
		case PE_INVALIDMEM :
			errore.append("Invalid GetMem Command.");
			break;
		case PE_INVALIDGET :
			errore.append("Invalid GetData Command.");
			break;
		case PE_INVALIDSET:
			errore.append("Invalid SetData Command.");
			break;
		case PE_INVALIDHEADER:
			errore.append("Invalid Header.");
			break;
		case PE_INVALIDDATASTRING:
			errore.append("Invalid Data String.");
			break;
		case PE_INVALIDDATAPROPERTY:
			errore.append("Invalid Data Property.");
			break;
		case PE_OBJECTDATA:
			errore.append("Error in Object Data.");
			break;
		case PE_LIGHTDATA:
			errore.append("Error in Light Data.");
			break;
		case PE_MATERIALDATA:
			errore.append("Error in Material Data.");
			break;
		case PE_UNKNOWNREASON:
			errore.append("Unknown Callback Reason.");
			break;
		case PE_UNKNOWNERROR:
			errore.append("Unknown Error.");
			break;
		default:
			errore.append("Unknown Error Code.");
			break;
	}
	MessageBox(NULL,errore.c_str(),"Error in Callback",MB_ICONERROR);

}
#endif

[!if CLASS_REFERENCES]
//This function returns a string made of all data
//needed to import a basic cube in DeleD.
Primitive CreateDeleDCube(int id){
	String MyChars;
	//create a cube object to pass to DeleD
	Primitive cube;
	cube.name=String("PluginCube");
	cube.id=id;
	cube.tag=String("cube created with plugin");
	cube.visible=true;
	cube.type=PRIMITIVE_TYPE::CUBE;
	cube.snapmethod=String("vertex");
	cube.groupid=-1;
	cube.autoUV=true;
	cube.comments=String("no more than a cube");
	cube.addVertex(PrimitiveVertex(0,Vertex(128,0,128)));
	cube.addVertex(PrimitiveVertex(1,Vertex(-128,0,128)));
	cube.addVertex(PrimitiveVertex(2,Vertex(-128,0,-128)));
	cube.addVertex(PrimitiveVertex(3,Vertex(128,0,-128)));
	cube.addVertex(PrimitiveVertex(4,Vertex(128,128,128)));
	cube.addVertex(PrimitiveVertex(5,Vertex(-128,128,128)));
	cube.addVertex(PrimitiveVertex(6,Vertex(-128,128,-128)));
	cube.addVertex(PrimitiveVertex(7,Vertex(128,128,-128)));
	Poly poly(0);
	poly.addVertex(PolyVertex(0,UVCoords(1.0,0.0)));
	poly.addVertex(PolyVertex(1,UVCoords(-1.0,0.0)));
	poly.addVertex(PolyVertex(5,UVCoords(-1.0,1.0)));
	poly.addVertex(PolyVertex(4,UVCoords(1.0,1.0)));
	cube.addPoly(poly);
	poly=Poly(0);
	poly.addVertex(PolyVertex(1,UVCoords(1.0,0.0)));
	poly.addVertex(PolyVertex(2,UVCoords(-1.0,0.0)));
	poly.addVertex(PolyVertex(6,UVCoords(-1.0,1.0)));
	poly.addVertex(PolyVertex(5,UVCoords(1.0,1.0)));
	cube.addPoly(poly);
	poly=Poly(0);
	poly.addVertex(PolyVertex(2,UVCoords(-1.0,0.0)));
	poly.addVertex(PolyVertex(3,UVCoords(1.0,0.0)));
	poly.addVertex(PolyVertex(7,UVCoords(1.0,1.0)));
	poly.addVertex(PolyVertex(6,UVCoords(-1.0,1.0)));
	cube.addPoly(poly);
	poly=Poly(0);
	poly.addVertex(PolyVertex(3,UVCoords(-1.0,0.0)));
	poly.addVertex(PolyVertex(0,UVCoords(1.0,0.0)));
	poly.addVertex(PolyVertex(4,UVCoords(1.0,1.0)));
	poly.addVertex(PolyVertex(7,UVCoords(-1.0,1.0)));
	cube.addPoly(poly);
	poly=Poly(0);
	poly.addVertex(PolyVertex(3,UVCoords(1.0,-1.0)));
	poly.addVertex(PolyVertex(2,UVCoords(-1.0,-1.0)));
	poly.addVertex(PolyVertex(1,UVCoords(-1.0,1.0)));
	poly.addVertex(PolyVertex(0,UVCoords(1.0,1.0)));
	cube.addPoly(poly);
	poly=Poly(0);
	poly.addVertex(PolyVertex(4,UVCoords(1.0,-1.0)));
	poly.addVertex(PolyVertex(5,UVCoords(-1.0,-1.0)));
	poly.addVertex(PolyVertex(6,UVCoords(-1.0,1.0)));
	poly.addVertex(PolyVertex(7,UVCoords(1.0,1.0)));
	cube.addPoly(poly);
	return cube;
}

void GetMaterials( String materials_data, bool onlyid, Scene *scene ){
	XMLNode main_node=XMLNode::parseString(materials_data.c_str());
	XMLNode node=main_node.getChildNode("materials");
	int num_category=node.nChildNode("category");
	for(int i=0;i<num_category;i++)
	{
		MaterialCategory mat_cat;
		mat_cat.name=String(node.getChildNode("category",i).getAttribute("name"));
		int num_mats=node.getChildNode("category",i).nChildNode("material");
		for(int j=0;j<num_mats;j++)
		{
			Material material;
			material.id=node.getChildNode("category",i).getChildNode("material",j).getAttributeAsInt("id");
			if(!onlyid)
			{
				material.name=String(node.getChildNode("category",i).getChildNode("material",j).getAttribute("name"));
				material.used=node.getChildNode("category",i).getChildNode("material",j).getAttributeAsBool("used");
				material.lightmap=node.getChildNode("category",i).getChildNode("material",j).getAttributeAsBool("lightmap");
				material.castShadows=node.getChildNode("category",i).getChildNode("material",j).getAttributeAsBool("castShadows");
				material.receiveShadows=node.getChildNode("category",i).getChildNode("material",j).getAttributeAsBool("receiveShadows");
				if(!node.getChildNode("category",i).getChildNode("material",j).getChildNode("comments").isEmpty())
					material.comments=String(node.getChildNode("category",i).getChildNode("material",j).getChildNode("comments").getText());
				if(!node.getChildNode("category",i).getChildNode("material",j).getChildNode("tag").isEmpty())
					material.tag=String(node.getChildNode("category",i).getChildNode("material",j).getChildNode("tag").getText());

				int num_layers=node.getChildNode("category",i).getChildNode("material",j).nChildNode("layer");
				for(int k=0;k<num_layers;k++)
				{
					Layer layer;
					layer.type=String(node.getChildNode("category",i).getChildNode("material",j).getChildNode("layer",k).getAttribute("type"));
					layer.blend=String(node.getChildNode("category",i).getChildNode("material",j).getChildNode("layer",k).getAttribute("blend"));
					if(layer.type==LAYER_TYPE::COLOR)
						layer.color=Color(node.getChildNode("category",i).getChildNode("material",j).getChildNode("layer",k).getChildNode("color").getAttributeAsInt("r"),
						node.getChildNode("category",i).getChildNode("material",j).getChildNode("layer",k).getChildNode("color").getAttributeAsInt("g"),
						node.getChildNode("category",i).getChildNode("material",j).getChildNode("layer",k).getChildNode("color").getAttributeAsInt("b"),
						node.getChildNode("category",i).getChildNode("material",j).getChildNode("layer",k).getChildNode("color").getAttributeAsInt("a"));
					else
						layer.file=String(node.getChildNode("category",i).getChildNode("material",j).getChildNode("layer",k).getChildNode("texture").getAttribute("file"));
					material.addLayer(layer);
				}
				mat_cat.addMaterial(material);
			}
		}
		scene->addMaterialCategory(mat_cat);
	}

};


void GetLights(String lights_data,bool onlyid,Scene *scene){
	XMLNode main_node=XMLNode::parseString(lights_data.c_str());
	XMLNode node=main_node.getChildNode("lights");
	int num_lights=node.nChildNode("light");
	for(int i=0;i<num_lights;i++)
	{
		Light light;
		light.id=node.getChildNode("light",i).getAttributeAsInt("id");
		if(!onlyid)
		{light.name=String(node.getChildNode("light",i).getAttribute("name"));
		light.type=String(node.getChildNode("light",i).getAttribute("type"));
		light.visible=node.getChildNode("light",i).getAttributeAsBool("visible");
		light.active=node.getChildNode("light",i).getAttributeAsBool("active");
		light.intensity=node.getChildNode("light",i).getAttributeAsBool("intensity");
		light.range=node.getChildNode("light",i).getAttributeAsBool("range");
		light.castShadows=node.getChildNode("light",i).getAttributeAsBool("castShadows");
		light.snap=node.getChildNode("light",i).getAttributeAsBool("snap");

		if(!node.getChildNode("light",i).getChildNode("comments").isEmpty())
			light.comments=String(node.getChildNode("light",i).getChildNode("comments").getText());
		if(!node.getChildNode("light",i).getChildNode("tag").isEmpty())
			light.tag=String(node.getChildNode("light",i).getChildNode("tag").getText());
		light.diffuse=Color(node.getChildNode("light",i).getChildNode("diffuse").getAttributeAsInt("r"),node.getChildNode("light",i).getChildNode("diffuse").getAttributeAsInt("g"),node.getChildNode("light",i).getChildNode("diffuse").getAttributeAsInt("b"));
		light.specular=Color(node.getChildNode("light",i).getChildNode("specular").getAttributeAsInt("r"),node.getChildNode("light",i).getChildNode("specular").getAttributeAsInt("g"),node.getChildNode("light",i).getChildNode("specular").getAttributeAsInt("b"));
		light.position=Vertex(node.getChildNode("light",i).getChildNode("position").getAttributeAsInt("x"),node.getChildNode("light",i).getChildNode("position").getAttributeAsInt("y"),node.getChildNode("light",i).getChildNode("position").getAttributeAsInt("z"));
		if(!node.getChildNode("light",i).getChildNode("direction").isEmpty())
			light.direction=Vertex(node.getChildNode("light",i).getChildNode("direction").getAttributeAsInt("x"),node.getChildNode("light",i).getChildNode("direction").getAttributeAsInt("y"),node.getChildNode("light",i).getChildNode("direction").getAttributeAsInt("z"));
		if(!node.getChildNode("light",i).getChildNode("attenuation").isEmpty())
		{
			light.constant=node.getChildNode("light",i).getChildNode("attenuation").getAttributeAsDouble("constant");
			light.linear=node.getChildNode("light",i).getChildNode("attenuation").getAttributeAsDouble("linear");
			light.quadratic=node.getChildNode("light",i).getChildNode("attenuation").getAttributeAsDouble("quadratic");
		};
		if(!node.getChildNode("light",i).getChildNode("cone").isEmpty())
		{
			light.innerangle=node.getChildNode("light",i).getChildNode("cone").getAttributeAsDouble("inner");
			light.outerangle=node.getChildNode("light",i).getChildNode("cone").getAttributeAsDouble("outer");
			light.falloff=node.getChildNode("light",i).getChildNode("cone").getAttributeAsDouble("falloff");
		};
		}
		scene->addLight(light);
	}
};
//This function returns a string made of all data
//to write objects on a DMF file.
//it includes ";" and as first element the number of objects
void GetPrimitives( String objects_data, bool onlyid,Scene *scene ){
	//we'll extract only data from DeleD string and copy them into a StringList
	//note that to complete this operation you need to call GetMaterials first
	//cause DeleD Objects UV depends on materials number.
	//no objects will be written if you've not loaded materials first.
	XMLNode main_node=XMLNode::parseString(objects_data.c_str());
	XMLNode node=main_node.getChildNode("primitives");
	int num_primitives=node.nChildNode("primitive");
	for(int i=0;i<num_primitives;i++)
	{
		Primitive obj;
		obj.id=node.getChildNode("primitive",i).getAttributeAsInt("id");
		if(!onlyid)
		{
			obj.name=String(node.getChildNode("primitive",i).getAttribute("name"));
			obj.type=String(node.getChildNode("primitive",i).getAttribute("type"));
			obj.visible=node.getChildNode("primitive",i).getAttributeAsBool("visible");
			obj.snapmethod=String(node.getChildNode("primitive",i).getAttribute("snap"));
			obj.autoUV=node.getChildNode("primitive",i).getAttributeAsBool("autoUV");
			obj.groupid=node.getChildNode("primitive",i).getAttributeAsInt("groupID");
			if(!node.getChildNode("primitive",i).getChildNode("comments").isEmpty())
				obj.comments=String(node.getChildNode("primitive",i).getChildNode("comments").getText());
			if(!node.getChildNode("primitive",i).getChildNode("tag").isEmpty())
				obj.tag=String(node.getChildNode("primitive",i).getChildNode("tag").getText());

			XMLNode verts=node.getChildNode("primitive",i).getChildNode("vertices");
			int num_verts=verts.nChildNode("vertex");
			for(int j=0;j<num_verts;j++)
			{
				PrimitiveVertex vert;
				vert.id=verts.getChildNode("vertex",j).getAttributeAsInt("id");
				vert.v.x=verts.getChildNode("vertex",j).getAttributeAsDouble("x");
				vert.v.y=verts.getChildNode("vertex",j).getAttributeAsDouble("y");
				vert.v.z=verts.getChildNode("vertex",j).getAttributeAsDouble("z");
				obj.addVertex(vert);
			}
			XMLNode polys=node.getChildNode("primitive",i).getChildNode("polygons");
			int num_poly=polys.nChildNode("poly");
			for(int j=0;j<num_poly;j++)
			{
				Poly poly;
				poly.mat=polys.getChildNode("poly",j).getAttributeAsInt("mid");
				int num_v=polys.getChildNode("poly",j).nChildNode("vertex");
				for(int k=0;k<num_v;k++)
				{
					PolyVertex vert(polys.getChildNode("poly",j).getChildNode("vertex",k).getAttributeAsInt("vid"));
					int uv=0;
					String u_s("u");
					String v_s("v");
					while(uv<4 && polys.getChildNode("poly",j).getChildNode("vertex",k).getAttribute((u_s+toString(uv)).c_str()))
					{
						vert.addUV(UVCoords(polys.getChildNode("poly",j).getChildNode("vertex",k).getAttributeAsDouble((u_s+toString(uv)).c_str()),polys.getChildNode("poly",j).getChildNode("vertex",k).getAttributeAsDouble((v_s+toString(uv)).c_str())));
						uv++;
					}
					poly.addVertex(vert);
				}
				obj.addPoly(poly);
			}
		}
		scene->addPrimitive(obj);
	}
};

void GetMaterials(bool selected,bool onlyid,Scene *scene){
	TCbData cbData;//callback data
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		if(!selected)  myStr = String("<request>\n   <materials subset=\"all\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//all primitives
		else
			myStr = String("<request>\n   <materials subset=\"selected\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//selected primitives onlymyStr = AddLengthToHeader(myStr);//add header
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						GetMaterials(myStr,onlyid,scene);
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
						}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
};


void GetPrimitives(bool selected,bool onlyid,Scene *scene){
	TCbData cbData;//callback data
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		if(!selected)
			myStr = String("<request>\n   <primitives subset=\"all\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//all primitives
		else
			myStr = String("<request>\n   <primitives subset=\"selected\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//selected primitives onlymyStr = AddLengthToHeader(myStr);//add header
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML= new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						GetPrimitives(myStr,onlyid,scene);
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
						}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
};


void GetLights(bool selected,bool onlyid,Scene *scene){
	TCbData cbData;//callback data
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		if(!selected)  myStr = String("<request>\n   <lights subset=\"all\" retrieveID=\"")+toString(onlyid)+String("\" />\n  </request>");//all primitives
		else
			myStr = String("<request>\n   <lights subset=\"selected\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//selected primitives onlymyStr = AddLengthToHeader(myStr);//add header
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						GetLights(myStr,onlyid,scene);
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
						}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
};

/*This retrieve the current complete scene from DeleD, it practically
*retrieve all materials,objects and lights and copy to the Scene wanted.
*\note A scene must exist, you can create with : \code Scene *myscene = new Scene();\endcode, once you created a scene you can use it with this and others getting functions, but note that lights are just added to current lists. And remember that lights are put in
* different lists (each for each type of light), see Scene for more details.
*/
void  GetScene(Scene *scene )
{
	GetMaterials(false,false,scene);
	GetPrimitives(false,false,scene);
	GetLights(false,false,scene);
};

void SetMaterials(Scene* scene){
	TCbData cbData;//callback data
	String MyData;//a string containing scene info

	//clear the string to store cube data
	MyData.clear();
	try{
		unsigned errors;// errors returned by callback
		//we're now creating string to pass to DeleD
		MyData=String("<scene version=\"1.6\">\n")+String(scene->to_deled_materials())+String("\n</scene>");
		cbData.RequestID = PR_SETDATA;//reason of callback
		cbData.ResponseSize = (MyData.length()+1);//size of data to be sent, a null terminated string
		cbData.RequestXML = new char[(MyData.length()+1)];//allocates memory for string
		sprintf(cbData.RequestXML,"%s",MyData.c_str());//copy memory to Data
		MyData.clear();//clear Data strings
		errors=callback(&cbData);//pass Data to callback retrieving eventual errors
		delete cbData.RequestXML;//destroy previously allocated memory
		if(errors) throw errors;
	}
	catch(unsigned exception){
		ErrorMessage(exception);//show error message (you can use this block to handle errors)

	}


};


void SetMaterials(Material* materia,String category,int highestID){
	TCbData cbData;//callback data
	String MyData;//a string containing scene info

	//clear the string to store cube data
	MyData.clear();
	try{
		unsigned errors;// errors returned by callback
		//we're now creating string to pass to DeleD
		MyData=String("<scene version=\"1.6\">\n<materials highestID=\"")+toString(highestID)+String(">\n");
		MyData=MyData+String("<category name=\"")+category+String("\">\n")+String(materia->to_deled())+String("\n</category>\n</materials>\n<scene>");
		cbData.RequestID = PR_SETDATA;//reason of callback
		cbData.ResponseSize = (MyData.length()+1);//size of data to be sent, a null terminated string
		cbData.RequestXML = new char[(MyData.length()+1)];//allocates memory for string
		sprintf(cbData.RequestXML,"%s",MyData.c_str());//copy memory to Data
		MyData.clear();//clear Data strings
		errors=callback(&cbData);//pass Data to callback retrieving eventual errors
		delete cbData.RequestXML;//destroy previously allocated memory
		if(errors) throw errors;
	}
	catch(unsigned exception){
		ErrorMessage(exception);//show error message (you can use this block to handle errors)
		}
};


void SetLights(Scene* scene){
	TCbData cbData;//callback data
	String MyData;//a string containing scene info
	//clear the string to store cube data
	MyData.clear();
	try{
		unsigned errors;// errors returned by callback
		//we're now creating string to pass to DeleD
		MyData=String("<scene version=\"1.6\">\n")+String(scene->to_deled_lights())+String("\n</scene>");
		cbData.RequestID = PR_SETDATA;//reason of callback
		cbData.ResponseSize = (MyData.length()+1);//size of data to be sent, a null terminated string
		cbData.RequestXML = new char[(MyData.length()+1)];//allocates memory for string
		sprintf(cbData.RequestXML,"%s",MyData.c_str());//copy memory to Data
		MyData.clear();//clear Data strings
		errors=callback(&cbData);//pass Data to callback retrieving eventual errors
		delete cbData.RequestXML;//destroy previously allocated memory
		if(errors) throw errors;
		}
	catch(unsigned exception){
		ErrorMessage(exception);//show error message (you can use this block to handle errors)
	}
};

void SetLights(Light* light,int highestID){
	TCbData cbData;//callback data
	String MyData;//a string containing scene info
	//clear the string to store cube data
	MyData.clear();
	try{
		unsigned errors;// errors returned by callback
		//we're now creating string to pass to DeleD
		MyData=String("<scene version=\"1.6\">\n<lights highestID=\"")+toString(highestID)+String(">\n");
		MyData=MyData+String(light->to_deled())+String("\n</lights>\n</scene>");
		cbData.RequestID = PR_SETDATA;//reason of callback
		cbData.ResponseSize = (MyData.length()+1);//size of data to be sent, a null terminated string
		cbData.RequestXML = new char[(MyData.length()+1)];//allocates memory for string
		sprintf(cbData.RequestXML,"%s",MyData.c_str());//copy memory to Data
		MyData.clear();//clear Data strings
		errors=callback(&cbData);//pass Data to callback retrieving eventual errors
		delete cbData.RequestXML;//destroy previously allocated memory
		if(errors) throw errors;
	}
	catch(unsigned exception){
		ErrorMessage(exception);//show error message (you can use this block to handle errors)
	}
};

void SetPrimitives(Scene *scene){
	TCbData cbData;//callback data
	String MyData;//a string containing scene info
	//clear the string to store cube data
	MyData.clear();
	try{
		unsigned errors;// errors returned by callback
		//we're now creating string to pass to DeleD
		MyData=String("<scene version=\"1.6\">\n")+String(scene->to_deled_primitives())+String("\n</scene>");
		cbData.RequestID = PR_SETDATA;//reason of callback
		cbData.ResponseSize = (MyData.length()+1);//size of data to be sent, a null terminated string
		cbData.RequestXML = new char[(MyData.length()+1)];//allocates memory for string
		sprintf(cbData.RequestXML,"%s",MyData.c_str());//copy memory to Data
		MyData.clear();//clear Data strings
		errors=callback(&cbData);//pass Data to callback retrieving eventual errors
		delete cbData.RequestXML;//destroy previously allocated memory
		if(errors) throw errors;
	}
	catch(unsigned exception){
		ErrorMessage(exception);//show error message (you can use this block to handle errors)
	}
};

void SetPrimitives(Primitive *obj,int highestID){
	TCbData cbData;//callback data
	String MyData;//a string containing scene info

	//clear the string to store cube data
	MyData.clear();
	try{
		unsigned errors;// errors returned by callback
		//we're now creating string to pass to DeleD
		MyData=String("<scene version=\"1.6\">\n")+String("<primitives highestID=\"")+toString(highestID)+String("\">\n")+String(obj->to_deled())+String("\n</primitives>\n")+String("</scene>");
		cbData.RequestID = PR_SETDATA;//reason of callback
		cbData.ResponseSize = (MyData.length()+1);
		cbData.RequestXML = new char[(MyData.length()+2)];//allocates memory for string
		sprintf(cbData.RequestXML,"%s\0",MyData.c_str());//copy memory to Data
		errors=callback(&cbData);//pass Data to callback retrieving eventual errors
		delete cbData.RequestXML;//destroy previously allocated memory
		if(errors) throw errors;
	}
	catch(unsigned exception){
		ErrorMessage(exception);//show error message (you can use this block to handle errors)
	}
};


int GetMaterialsHighestID()
{
	TCbData cbData;//callback data
	int ret_id=-1;
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		myStr = String("<request>\n   <materials subset=\"none\" retrieveID=\"true\" />\n  </request>");//all primitives
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						XMLNode main_node=XMLNode::parseString(myStr.c_str());
						XMLNode node=main_node.getChildNode("materials");
						if(!node.isEmpty())
							ret_id=node.getAttributeAsInt("highestID");
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return ret_id;
};


int GetPrimitivesHighestID()
{
	TCbData cbData;//callback data
	int ret_id=-1;
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		myStr = String("<request>\n   <primitives subset=\"none\" retrieveID=\"true\" />\n  </request>");//all primitives
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						XMLNode main_node=XMLNode::parseString(myStr.c_str());
						XMLNode node=main_node.getChildNode("primitives");
						if(!node.isEmpty())
							ret_id=node.getAttributeAsInt("highestID");
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return ret_id;
};

int GetLightsHighestID()
{
	TCbData cbData;//callback data
	int ret_id=-1;
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		myStr = String("<request>\n   <lights subset=\"none\" retrieveID=\"true\" />\n  </request>");//all primitives
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		//delete cbData.RequestXML;//destroy previously allocated memory
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						XMLNode main_node=XMLNode::parseString(myStr.c_str());
						XMLNode node=main_node.getChildNode("lights");
						if(!node.isEmpty())
							ret_id=node.getAttributeAsInt("highestID");
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return ret_id;
};
[!else]
String GetMaterials(bool selected, bool onlyid){
	TCbData cbData;//callback data
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		if(!selected)  myStr = String("<request>\n   <materials subset=\"all\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//all primitives
		else
			myStr = String("<request>\n   <materials subset=\"selected\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//selected primitives onlymyStr = AddLengthToHeader(myStr);//add header
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						StringList list=SubdivideString(myStr,String("\n"));
						list[0]="";
						list[list.size()-1]="";
						myStr=list.GetTextNewLine();
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return myStr;
};


String GetPrimitives(bool selected, bool onlyid){
	TCbData cbData;//callback data
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		if(!selected)
			myStr = String("<request>\n   <primitives subset=\"all\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//all primitives
		else
			myStr = String("<request>\n   <primitives subset=\"selected\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//selected primitives onlymyStr = AddLengthToHeader(myStr);//add header
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML= new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						StringList list=SubdivideString(myStr,String("\n"));
						list[0]="";
						list[list.size()-1]="";
						myStr=list.GetTextNewLine();
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return myStr;
};


String GetLights(bool selected, bool onlyid){
	TCbData cbData;//callback data
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		if(!selected)  myStr = String("<request>\n   <lights subset=\"all\" retrieveID=\"")+toString(onlyid)+String("\" />\n  </request>");//all primitives
		else
			myStr = String("<request>\n   <lights subset=\"selected\" retrieveID=\"")+toString(onlyid)+String("\" />\n</request>");//selected primitives onlymyStr = AddLengthToHeader(myStr);//add header
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						StringList list=SubdivideString(myStr,String("\n"));
						list[0]="";
						list[list.size()-1]="";
						myStr=list.GetTextNewLine();
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return myStr;
};

int GetMaterialsHighestID()
{
	TCbData cbData;//callback data
	int ret_id=-1;
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		myStr = String("<request>\n   <materials subset=\"none\" retrieveID=\"true\" />\n  </request>");//all primitives
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						XMLNode main_node=XMLNode::parseString(myStr.c_str());
						XMLNode node=main_node.getChildNode("materials");
						if(!node.isEmpty())
							ret_id=node.getAttributeAsInt("highestID");
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return ret_id;
};


int GetPrimitivesHighestID()
{
	TCbData cbData;//callback data
	int ret_id=-1;
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		myStr = String("<request>\n   <primitives subset=\"none\" retrieveID=\"true\" />\n  </request>");//all primitives
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						XMLNode main_node=XMLNode::parseString(myStr.c_str());
						XMLNode node=main_node.getChildNode("primitives");
						if(!node.isEmpty())
							ret_id=node.getAttributeAsInt("highestID");
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return ret_id;
};
int GetLightsHighestID()
{
	TCbData cbData;//callback data
	int ret_id=-1;
	unsigned errors;// errors returned by callback
	String myStr;
	myStr.clear();
	try{
		myStr = String("<request>\n   <lights subset=\"none\" retrieveID=\"true\" />\n  </request>");//all primitives
		cbData.RequestID = PR_GETMEM;//reason of callback is getting data wanted size
		cbData.ResponseSize = 0;//we don't know actual data length
		cbData.RequestXML = new char[(myStr.size()+1)];//allocate new memory
		sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy String to Data
		errors=callback(&cbData);//executes callback
		if(!errors) {
			if (cbData.ResponseSize > 0){//there's something to get
				try{
					unsigned errors1;// errors returned by callback
					cbData.RequestID = PR_GETDATA;//reason of callback
					cbData.ResponseXML = new char[cbData.ResponseSize+1];//allocate necessary memory
					sprintf(cbData.RequestXML,"%s",myStr.c_str());//copy header to let DeleD know what we want
					errors1=callback(&cbData);//executes callback
					if(!errors1){
						myStr.clear();
						myStr=String(cbData.ResponseXML);
						XMLNode main_node=XMLNode::parseString(myStr.c_str());
						XMLNode node=main_node.getChildNode("lights");
						if(!node.isEmpty())
							ret_id=node.getAttributeAsInt("highestID");
						delete cbData.RequestXML;//destroy previously allocated memory
						delete cbData.ResponseXML;//destroy previously allocated memory
					}
					else throw errors1;
				}catch(unsigned exception){ErrorMessage(exception);//show error message (you can use this block to handle errors)
				}}}
		else throw errors;
	}catch(unsigned exception){
		ErrorMessage(exception);
	}
	return ret_id;
};
String CreateDeleDCube(int id){
	String MyChars;
	//create a cube object to pass to DeleD
	MyChars=String("<primitive id=\"")+toString(id)+String("\" name=\"cube1\" type=\"cube\" visible=\"true\" snap=\"vertex\" autoUV=\"true\" groupID=\"-1\">\n")+
		String("<vertices>\n")+
		String("        <vertex id=\"0\" x=\"64\" y=\"-64\" z=\"0\" />\n        <vertex id=\"1\" x=\"-64\" y=\"-64\" z=\"0\" />\n        <vertex id=\"2\" x=\"-64\" y=\"-64\" z=\"-128\" />")+
		String("        <vertex id=\"3\" x=\"64\" y=\"-64\" z=\"-128\" />\n        <vertex id=\"4\" x=\"64\" y=\"64\" z=\"0\" />\n        <vertex id=\"5\" x=\"-64\" y=\"64\" z=\"0\" />\n        <vertex id=\"6\" x=\"-64\" y=\"64\" z=\"-128\" />\n        <vertex id=\"7\" x=\"64\" y=\"64\" z=\"-128\" />\n      </vertices>\n")+
		String("      <polygons>\n")+
		String("        <poly mid=\"0\">\n          <vertex vid=\"0\" u0=\"0.5\" v0=\"0.5\" />\n          <vertex vid=\"1\" u0=\"-0.5\" v0=\"0.5\" />\n          <vertex vid=\"5\" u0=\"-0.5\" v0=\"-0.5\" />\n          <vertex vid=\"4\" u0=\"0.5\" v0=\"-0.5\" />\n        </poly>\n")+
		String("        <poly mid=\"0\">\n          <vertex vid=\"1\" u0=\"0\" v0=\"0.5\" />\n          <vertex vid=\"2\" u0=\"-1\" v0=\"0.5\" />\n          <vertex vid=\"6\" u0=\"-1\" v0=\"-0.5\" />\n          <vertex vid=\"5\" u0=\"0\" v0=\"-0.5\" />\n        </poly>\n")+
		String("        <poly mid=\"0\">\n          <vertex vid=\"2\" u0=\"0.5\" v0=\"0.5\" />\n          <vertex vid=\"3\" u0=\"-0.5\" v0=\"0.5\" />\n          <vertex vid=\"7\" u0=\"-0.5\" v0=\"-0.5\" />\n          <vertex vid=\"6\" u0=\"0.5\" v0=\"-0.5\" />\n        </poly>\n")+
		String("        <poly mid=\"0\">\n          <vertex vid=\"3\" u0=\"1\" v0=\"0.5\" />\n          <vertex vid=\"0\" u0=\"0\" v0=\"0.5\" />\n          <vertex vid=\"4\" u0=\"0\" v0=\"-0.5\" />\n          <vertex vid=\"7\" u0=\"1\" v0=\"-0.5\" />\n        </poly>\n")+
		String("        <poly mid=\"0\">\n          <vertex vid=\"6\" u0=\"-0.5\" v0=\"-1\" />\n          <vertex vid=\"7\" u0=\"0.5\" v0=\"-1\" />\n          <vertex vid=\"4\" u0=\"0.5\" v0=\"0\" />\n          <vertex vid=\"5\" u0=\"-0.5\" v0=\"0\" />\n        </poly>\n")+
		String("        <poly mid=\"0\">\n          <vertex vid=\"1\" u0=\"-0.5\" v0=\"0\" />\n          <vertex vid=\"0\" u0=\"0.5\" v0=\"0\" />\n          <vertex vid=\"3\" u0=\"0.5\" v0=\"1\" />\n          <vertex vid=\"2\" u0=\"-0.5\" v0=\"1\" />\n        </poly>\n")+
		String("      </polygons>\n    </primitive>\n");
	return MyChars;
}
void SetData(String data){
	TCbData cbData;//callback data
	try{
		unsigned errors;// errors returned by callback
		//we're now creating string to pass to DeleD
		cbData.RequestID = PR_SETDATA;//reason of callback
		cbData.ResponseSize = (data.length()+1);
		cbData.RequestXML = new char[(data.length()+1)];//allocates memory for string
		sprintf(cbData.RequestXML,"%s",data.c_str());//copy memory to Data
		errors=callback(&cbData);//pass Data to callback retrieving eventual errors
		delete cbData.RequestXML;//destroy previously allocated memory
		if(errors) throw errors;
	}
	catch(unsigned exception){
		ErrorMessage(exception);//show error message (you can use this block to handle errors)
	}
};

[!endif]